#include <stdlib.h>
#include <stdint.h>
#include <stdio.h>
#include <math.h>
/*
#include "tree/eval.h"
#include "tree/tree.h"
#include "tree/packed.h"
*/

#include "asdf/mesh.h"
#include "asdf/asdf.h"
#include "asdf/file_io.h"
#include "asdf/import.h"

int main()
{
/*
    MathTree* X = X_tree();
    MathTree* neg_one = constant_tree(-1);
    MathTree* s1 = add_tree(X, neg_one);
    MathTree* s2 = sub_tree(neg_one, X);
    
    MathTree* max = max_tree(s1, s2);
    
    PackedTree* p = make_packed(max);
    Interval i = eval_i(p, (Interval){-2, -1.5}, (Interval){0,0}, (Interval){0,0});
    printf("%g, %g\n", i.lower, i.upper);
    
    print_tree_verbose(max);
    disable_nodes(p);
    
    print_tree_verbose(max);
    enable_nodes(p);
    
    free_tree(X);
    free_tree(neg_one);
    free_tree(s1);
    free_tree(s2);
    
    free_tree(max);
    free_packed(p);
    */
    
//    ASDF* ballerina = import_vol("ballerina10.vol", 255, 255, 511, 19.5, 0.1);
//    printf("Cell count: %i\n", count_cells(ballerina));
//    asdf_write(ballerina, "lace.asdf");


    ASDF* asdf = asdf_read("key.asdf");
    uint32_t leafs = count_leafs(asdf);
    float* vdata = malloc(leafs*6*2*3*6*sizeof(float));
    uint32_t vcount = 0;
    uint32_t* idata = malloc(leafs*6*2*3*sizeof(uint32_t));
    uint32_t icount = 0;
    int halt = 0;
    
    triangulate(asdf, vdata, &vcount, idata, &icount, &halt);
    printf("Got %i vertices and %i triangles\n", vcount/6, icount/3);
    
    free_asdf(asdf);
    free(vdata);
    free(idata);

    return 0;
}