#ifndef SOLVER_H
#define SOLVER_H

#include <stdint.h>

#include "util/region.h"

struct PackedTree_;

/*  render8
 *
 *  Recursively renders a tree into a given region.
 *  Aborts if *halt becomes true.
 */
void render8(struct PackedTree_* tree, Region region,
             uint8_t** img, int* halt);
             
/*  region8
 *
 *  Renders a tree pixel-by-pixel into a given region,
 *  using the eval_r function to find an array of results in
 *  a single pass through the tree.
 *
 */
void region8(struct PackedTree_* tree, Region region, uint8_t** img);

#endif