from koko.c.tree import *
            
################################################################################

def circle(x0, y0, r):
    s = move(MathTree.sqrt(MathTree.pow(X,2)+MathTree.pow(Y,2))-r, x0, y0)
    s.shape = True
    return s

def triangle(x0, y0, x1, y1, x2, y2):
    def edge(x, y, dx, dy):
        return dy*(X-x)-dx*(Y-y)
    e0 = edge(x0, y0, x1-x0, y1-y0)
    e1 = edge(x1, y1, x2-x1, y2-y1)
    e2 = edge(x2, y2, x0-x2, y0-y2)
    s = -MathTree.min(e0, MathTree.min(e1, e2))
    s.shape = True
    return s

def rectangle(x0, x1, y0, y1):
    s = MathTree.max(MathTree.max(x0 - X, X - x1),
                     MathTree.max(y0 - Y, Y - y1))
    s.shape = True
    return s
    
################################################################################

def move(shape, dx, dy, dz=0):
    return shape.map((X - dx), (Y - dy), (Z - dz))

def rotate(part, angle):
    angle *= math.pi/180
    return part.map(X= math.cos(angle)*X+math.sin(angle)*Y,
                    Y=-math.sin(angle)*X+math.cos(angle)*Y)


    
################################################################################

def reflect_x(part, x0=0):
    return part.map(X=2*x0-X)

def reflect_y(part, y0=0):
    return part.map(Y=2*y0-Y)
        
def reflect_xy(part):
    return part.map(X=Y, Y=X)
    
################################################################################
    
def scale_x(part, x0, sx):
    return part.map(X=x0+(X-x0)/sx)

def scale_y(part, y0, sy):
    return part.map(Y=y0+(Y-y0)/sy)

def scale_xy(part, x0, y0, sxy):
    return part.map(X=X/sxy, Y=y0+(Y-y0)/sxy)
    
################################################################################

def shear_x_y(part, y0, y1, dx0, dx1):
    return part.map(X=X-dx0-(dx1-dx0)*(Y-y0)/(y1-y0))

################################################################################

def taper_x_y(part, x0, y0, y1, s0, s1):
    return part.map(X=x0+(X-x0)*(y1-y0)/(s1*(Y-y0)+s0*(y1-Y)))
